return function(button_list, stepstype, skin_params)
	local ret = {}
	local rots  = {
		Left      = 90,
		Down      = 0,
		Up        = 180,
		Right     = 270,
		UpLeft    = 135,
		UpRight   = 225, 
		DownLeft  = 45,
		DownRight = 315
	}
	local tap_redir= {}
	local anime_explosion= {
		TapNoteSubType_Hold= {2,3},
		TapNoteSubType_Roll= {4,5}
	}
	for i, button in ipairs(button_list) do
		ret[i] = Def.ActorFrame {
			InitCommand = function(self)
				self:rotationz(rots[button] or 0):draworder(notefield_draw_order.explosion)
			end,
			WidthSetCommand = function(self, param)
				param.column:set_layer_fade_type(self, "FieldLayerFadeType_Explosion")
			end,
			Def.Sprite {
				Texture = "Down_explosion_note",
				InitCommand = function(self)
					self:diffusealpha(0):animate(false)
				end,
				ColumnJudgmentCommand= function(self, param)
					local diffuse = {
						TapNoteScore_W1    = { 1.0, 1.0, 1.0, 1 },
						TapNoteScore_W2    = { 1.0, 1.0, 0.3, 1 },
						TapNoteScore_W3    = { 0.0, 1.0, 0.4, 1 },
						TapNoteScore_W4    = { 1.0, 1.0, 1.0, 0 },
						TapNoteScore_W5    = { 1.0, 1.0, 1.0, 0 },
						HoldNoteScore_Held = { 1.0, 1.0, 0.3, 1 },
					}
					local exp_color= diffuse[param.tap_note_score or param.hold_note_score]
					local exp_state= ((param.tap_note_score and param.tap_note_score=="TapNoteScore_W1")
										or (param.hold_note_score and param.hold_note_score=="HoldNoteScore_Held")) and 0 or 1
					if exp_color then
						self:stoptweening()
							:blend("BlendMode_Add")
							:diffuse(exp_color)
							:setstate(exp_state)
							:zoom(1)
							:linear(0.075)
							:zoom(1.1)
							:linear(0.075)
							:diffusealpha(0)
					end
				end
			},
			Def.Sprite{
				Texture= "hit_mine_explosion", InitCommand= function(self)
					self:visible(false)
				end,
				ColumnJudgmentCommand= function(self, param)
					if param.tap_note_score == "TapNoteScore_HitMine" then
						self:visible(true):finishtweening()
							:blend("BlendMode_Add"):diffuse{1, 1, 1, 1}
							:zoom(1):rotationz(0):decelerate(.3):rotationz(90)
							:linear(.3):rotationz(180):diffusealpha(0)
							:sleep(0):queuecommand("hide")
					end
				end,
				hideCommand= function(self)
					self:visible(false)
				end,
			},
			Def.Sprite{
				Texture = "Down_explosion_hold",
				InitCommand = function(self)
					self:diffusealpha(0)
				end,
				-- The Hold command is the way to respond to a hold being active.
				-- When there is a hold in the column, the Hold command will be sent.
				-- The frame after a hold ends, it will be sent with nothing in param.
				-- The param argument has three elements:
				-- {
				--   type, -- A TapNoteSubType enum string.
				--   life, -- The life value of the hold.  When the hold is dropped,
				--         -- this will decrease from 1 to 0.
				--   start, -- True if this is the first frame of the hold.
				--   finished, -- True if the hold ended last frame.
				-- }
				-- This example picks a color based on the type.
				HoldCommand= function(self, param)
					if param.type and param.type=="TapNoteSubType_Hold" then
						if param.start then
							self:finishtweening()
								:diffusealpha(1)
						elseif param.finished or param.life<=0 then
							self:stopeffect():diffusealpha(0)
						end
					end
				end,
			},
			Def.Sprite{
				Texture = "Down_explosion_roll",
				InitCommand = function(self)
					self:diffusealpha(0)
				end,
				HoldCommand= function(self, param)
					if param.type and param.type=="TapNoteSubType_Roll" then
						if param.start then
							self:finishtweening()
								:diffusealpha(1)
						elseif param.finished or param.life<=0 then
							self:stopeffect():diffusealpha(0)
						end
					end
				end,
			},
		}
	end
	return ret
end
